 //Robo Cup  on-line coach
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//keisei wo arawasu graph
//
public class KeiseiGraph extends Canvas implements Observer{

	/******************************************/
	/*                 field                  */
	/******************************************/
       Image buff = null ;
       Image backField = null;
       Graphics gbuff, gbf;

	//canvas width ,height
       int width = 450;
       int height = 200;
	//graph width, height
       int gwidth = 300;
       int gheight = 200;

	int score;
        int time = 0;
   
	double SCALE_X = (double)gwidth / 6000;

	/*********************************************/
	/*            constructor                    */
	/*********************************************/

	KeiseiGraph(){
			
	   //this(width,height);
  
		setSize(width, height);

        }
		
	KeiseiGraph(int width, int height) {
	      
		this.width = width;
		this.height = height;

		setSize(width, height);
	 
	} 
	
	/*******************************************/
	/*             method                      */
	/*******************************************/

	/************* override Canvas **************/   

	public void paint(Graphics g) {
		
		//System.out.println("called paint();");

		if (buff == null ) {                     
         	buff = createImage(width, height);
			gbuff = buff.getGraphics();

		}
		
		if (backField == null) {
			backField = createImage(width, height);
			gbf = backField.getGraphics();
			setBackField(gbf);

			gbuff.drawImage(backField,0,0,this);
		}		
	
		g.drawImage(buff ,0,0,this);
	}

	public void update(Graphics g){

		paint(g);

	}

	/***************** override Observer *********************/
	public void update(Observable o, Object arg){

		
				

	}
	
	/**********************************************************/	

	public void drawBackField(){

		gbuff.drawImage(backField,0,0,this);			

	}	

	public void clearGraphicsBuffer(){

		buff = null;
		backField = null;
	}

	public void createGraphicsBuffer(){

		buff = createImage(width, height);
		gbuff = buff.getGraphics();

		backField = createImage(width, height);
		gbf = backField.getGraphics();
		setBackField(gbf);

		gbuff.drawImage(backField,0,0,this);
	}

    private void setBackField(Graphics gb){

	Font defFont = gb.getFont();

	gb.setFont(new Font("b", Font.BOLD, 16));

	gb.setColor(Color.red);
        gb.drawRect(0,0,gwidth-1, gheight-1);
	gb.drawLine(0,gheight/2,gwidth,gheight/2);
	gb.drawString("+", gwidth - 20, 20);
	gb.drawString("-", gwidth - 20, gheight - 20);

	int fontSize = 12;
	int lineLength = 20;
	gb.setFont(new Font("a", Font.BOLD, fontSize));

	gb.setColor(Eval.color);
	gb.drawLine(gwidth+10, 40-fontSize - 5, gwidth+10+lineLength, 40-fontSize -5);
	gb.drawString(Eval.NAME,gwidth,40);	
	gb.setColor(Shihairitsu.color);
	gb.drawLine(gwidth+10, 70-fontSize - 5, gwidth+10+lineLength, 70-fontSize -5);
	gb.drawString(Shihairitsu.NAME,gwidth,70);
	gb.setColor(BallPos.color);
	gb.drawLine(gwidth+10, 100-fontSize - 5, gwidth+10+lineLength, 100-fontSize -5);
        gb.drawString(BallPos.NAME,gwidth,100);

	gb.setFont(defFont);

    }

	//override java.awt.Component 
	public Dimension getPreffererdSize(){

		return getSize();

	}    

	//hyouka chi wo hyoujisuru
    public void draw(int time, Object o0, Object o1){

	if (o0 instanceof Eval){

	    Eval eval0 = (Eval)o0;
	    Eval eval1 = (Eval)o1;

	    gbuff.setColor(eval0.getColor());
	    
	    gbuff.drawLine(fitScaleX(eval0.time),fitScaleY(eval0.eval,eval0.getMaxY(), eval0.getMinY()), fitScaleX(eval1.time), fitScaleY(eval1.eval,eval1.getMaxY(),eval1.getMinY()));


	 }else if (o0 instanceof BallPos){

	     BallPos bp0 = (BallPos)o0; 
	     BallPos bp1 = (BallPos)o1;

	     gbuff.setColor(bp0.getColor()); 

	     gbuff.drawLine(fitScaleX(bp0.time),fitScaleY(bp0.ballInMySideRate,bp0.getMaxY(), bp0.getMinY()), fitScaleX(bp1.time), fitScaleY(bp1.ballInMySideRate,bp0.getMaxY(),bp0.getMinY()));

	 }else if (o0 instanceof Shihairitsu){

	     Shihairitsu sr0 = (Shihairitsu)o0;
	     Shihairitsu sr1 = (Shihairitsu)o1;
	     
	     gbuff.setColor(sr0.getColor());

	     gbuff.drawLine(fitScaleX(sr0.time),fitScaleY(sr0.shihairitsu,sr0.getMaxY(), sr0.getMinY()), fitScaleX(sr1.time), fitScaleY(sr1.shihairitsu,sr1.getMaxY(),sr1.getMinY()));
	     
	 }

	repaint();

    }

	private int fitScaleX(int x){

            return (int)(x * SCALE_X);  

        }

	private int fitScaleY(double val, int max, int min){

		System.out.println("val = "+val);
	   
	    int y  = (int)(gheight - ((val - min) * gheight / (max - min)));
	    
	    if (y < 1){y = 1;}
	    else if (y >= gheight ){ y = gheight -1;} 

	    return y;

	}

}


