/***************************************/
/*	   		               */
/*	      SoccerLib.java	       */
/*	 饤֥꡼ߤʼ	       */
/*	   		               */
/***************************************/


import java.io.*;
import java.lang.*;

class SoccerLib  implements Serializable
{ 
	final static int	simulator_step 	= 100; 

        /************************/
        /* եɥѥ᡼ */
        /************************/
	final static int	sx 		= 16;
	final static int	sy 		= 11;
	final static double	pitch_l 	= 105.0; /* Pitch Length */
	final static double	pitch_w 	= 68.0; /* Pitch Width  */
	final static double	pena_x 		= 36.0; /* Penalty Area Base X */ 
	final static double	pena_y 		= 20.16; /* Penalty Area Base Y */ 
        final static double     goal_s          = 14.02; /* Goal Size */

        /**************************/
        /* ץ쥤䡼Υѥ᡼ */
        /**************************/
	final static double	kick_able    = 1.0085; /* Kick Able Area */
	final static double	ball_decay   = 0.94;  
	final static double	agent_decay  = 0.4;
        final static double     StaminaMax   = 3600.0;
        final static double     stamina_inc  = 20.0; /* 100ms륹ߥ */ 
        final static double     dash_rate    = 0.006; 
        final static double     kick_rate    = 0.016; 
        final static double     normal_range = 90.0;  /* siya */
        final static double     narrow_range = 45.0;  
        final static double     wide_range   = 180.0;  


  /**************************************************************************************/
  /**************************************************************************************/
  /**************************************************************************************/
  /**************************************************************************************/
  /**************************************************************************************/

        /**********************************/
	/* 顼ɸ򥹥⡼ɸѴ */
	/**********************************/
	public static int l2sx(double x)
	{
		int s_x;
		s_x = (int)((x+pitch_l/2)*sx/pitch_l);
		return s_x;
	} 
	public static int l2sy(double y)
	{
		int s_y;
		s_y = (int)((y+pitch_w/2)*sy/pitch_w);
		return s_y;
	} 

	/************************/
	/* ܡɤγ */
	/************************/
	public static double check_angle(double x)
	{
		x = 5+10/x;
		return x;
	}

	/**********************/
	/* ͤ;ʬʬڤ */
	/**********************/
	public static double cut(double jou,double ge,double x)
	{
		x = x>jou?jou:x<ge?ge:x;
		return x;
	}

	/**********/
	/* ˸² */
	/**********/
	public static double restrict(double x)
	{
		x = x>180?x-360:x<-180?x+360:x;
		return x;
	}

	/*****************/
	/* 1ƥåԤ */
	/*****************/
	public static void onestepwait()
	{
		try
		{  
			Thread.sleep(SoccerLib.simulator_step);  
		}
		catch(Exception e){}  
	}  

	/*******************************/
	/* ͤ(Java.Math٤) */
	/*******************************/
	public static double Abs(double x) 
	{
		if(x<0.0)
			x*=-1.0;
		return x;
	}

	/**************/
	/* 褷ޤ */
	/**************/
	public static double Pow(double x)
	{
		return x * x;
	}

	/***************/	
	/* Square Root */	
	/***************/	
	public static double Sqrt(double x)
	{	
		return Math.sqrt(x);
	}

	/*******************************/
	/* Ρޥdirȥ饸Ѵ */
	/*******************************/
	public static double Rad2Deg(double x)
	{
		double deg;
		deg = x * 180.0 / 3.14;
		return deg;
	}

	public static double Deg2Rad(double x)
	{
		double rad;
		rad = x * 3.14 / 180.0;
		return rad;
	}

	/************/	
	/* Ѵؿ */
	/************/	
	public static double Sin(double x)
	{
		return Math.sin(x);
	}

	public static double Cos(double x)
	{
		return Math.cos(x);
	}

        /**********************************/
        /* DegRadؤѴդѴؿ */
        /**********************************/
	public static double Sin2Rad(double x)
	{
	        double tmp_sin;
		tmp_sin = Math.sin(x);
		return Deg2Rad(tmp_sin);
	}

	public static double Cos2Rad(double x)
	{
	        double tmp_cos;
		tmp_cos = Math.cos(x);
		return Deg2Rad(tmp_cos);
	}

        /**********************************************************/
	/* ɸͤ鼫ʬθƤФƤγ٤ */
        /**********************************************************/
        /*  x, yɸȳ  */
	public static double Calc_dir(double x,double y,double dir)
	{
		double tmp;
		tmp = Rad2Deg(Math.atan2(y,x))-dir;
		tmp = restrict(tmp);
		return tmp;
	}
        /*  x, yɸ */
	public static double Calc_dir(double x,double y)
	{
		double tmp,tmp_x,tmp_y;
		tmp_x = x - MyBody.x;
		tmp_y = y - MyBody.y;
		tmp = Rad2Deg(Math.atan2(tmp_y,tmp_x))-MyBody.dir;
		tmp = restrict(tmp);

		return tmp;
	}

	/**************/
	/* Υη׻ */
	/**************/
	public static double Calc_dis(double x,double y)
	{
		double 	tmp;
		tmp = Sqrt(Pow(x-MyBody.x) + Pow(y-MyBody.y));
		return tmp;
	}

        /****************/
	/* Υ */
        /****************/
	public static double Pit(double x,double y)
	{
		return Sqrt(Pow(x) + Pow(y));
	}

        /****************************/ 
        /* 2ĤΤ,礭֤ͤ */
        /****************************/ 
        public static double Com_max(double x, double y)
        {
	  return ((x)>(y)?(x):(y));
        } 
        /****************************/ 
        /* 2ĤΤ,֤ͤ */
        /****************************/ 
        public static double Com_min(double x, double y)
        {
	  return ((x)<(y)?(x):(y));
        } 

	/**************************/
	/* ܡɤȽꤹ */
	/**************************/
	public static boolean Chase_decision()
	{
		if(Ball.dis < 6.0)
			return true;
		else if(Ball.x < MyBody.max_x && Ball.x > MyBody.min_x && 
			Ball.y < MyBody.max_y && Ball.y > MyBody.min_y)
		  {
			return true;
		  }
		else
			return false;
	}	

        /********************************/
	/* ʬμϰ⤫ȽǤ */
        /********************************/
	public static boolean Check_Pos()
	{
		double err = 3.5; /* ϰ */
		if(	MyBody.x < (MyBody.mypos_x + err) && 
		   	MyBody.x > (MyBody.mypos_x - err) &&
		   	MyBody.y < (MyBody.mypos_y + err) && 
			MyBody.y > (MyBody.mypos_y - err ))
		{
			return true;
		}
		else
		{
			return false;
		}
	}

       /********************************************/
       /* ꤵ줿֤ʬμϰ⤫Ƚ */
       /********************************************/
	public static boolean predict_decision(double x, double y)
	{
		if( x < (MyBody.mypos_x + SoccerLib.kick_able) && 
		    x > (MyBody.mypos_x - SoccerLib.kick_able) &&
		    y < (MyBody.mypos_y + SoccerLib.kick_able) && 
		    y > (MyBody.mypos_y - SoccerLib.kick_able))
		{
			return true;
		}
		else
		{
			return false;
		}
	}

} 








